//
//  BannerTemplatePresenter.swift
//  SuperSpaManagement
//
//  Created by PHAM ANH TUAN on 3/18/21.
//  Copyright (c) 2021 ___ORGANIZATIONNAME___. All rights reserved.
//
//  This file was generated by the 🐍 VIPER generator
//

import Foundation
import Action
import RxSwift
import RxCocoa

protocol BannerTemplateListener {
    func bannerTemplateDidGetErorr(_ error: SuperSpaManagementError)
}

protocol BannerTemplateViewInterface: ViewInterface {
    var categoriesItem: BehaviorRelay<[CategoryItem]> { get }
}

final class BannerTemplatePresenter: BannerTemplatePresenterInterface {

    // MARK: - Private properties -
    
    private lazy var getCategoriesItem = makeGetCategoriesItem()
    private let disposeBag = DisposeBag()
    
    private unowned let view: BannerTemplateViewInterface
    private let interactor: BannerTemplateInteractorInterface
    private let wireframe: BannerTemplateWireframeInterface

    // MARK: - Lifecycle -

    init(view: BannerTemplateViewInterface, interactor: BannerTemplateInteractorInterface, wireframe: BannerTemplateWireframeInterface) {
        self.view = view
        self.interactor = interactor
        self.wireframe = wireframe
        
        configurePresenter()
    }
}

// MARK: - Extensions -

extension BannerTemplatePresenter {
    private func configurePresenter() {
        
        getCategoriesItem
            .elements
            .bind(to: view.categoriesItem)
            .disposed(by: disposeBag)
        
        getCategoriesItem.execute()
    }
}

extension BannerTemplatePresenter {
    func makeGetCategoriesItem() -> Action<Void, [CategoryItem]> {
        return Action<Void, [CategoryItem]> { [unowned self] in
            return interactor.getCategoryItems()
        }
    }
}
